#ifndef	_CCILIB_H
#define	_CCILIB_H

#ifndef	NULL
#	define	NULL	0
#endif
#ifndef	NORMAL
#	define	NORMAL	(0)
#endif
#ifndef	ERROR
#	define	ERROR	(-1)
#endif
#ifndef	ERR
#	define	ERR		ERROR
#endif
#ifndef	FALSE
#	define	FALSE	(0)
#endif
#ifndef	TRUE
#	define	TRUE	(1)
#endif

/*************************************************************************
*	bWCu
*************************************************************************/
#ifndef	BUFSIZ
#	define	BUFSIZ	(512)
#endif
#ifndef	EOF
#	define	EOF		(-1)
#endif
#define	SEEK_SET	(0)
#define	SEEK_CUR	(1)
#define	SEEK_END	(2)

/*************************************************************************
*	Cxgp
*************************************************************************/

#define	GET_EVTSBJ_PTR(sbj)	GetEvtSbjPtr(sbj)

#ifndef	EVT_CANCEL
#define	EVT_CANCEL	(-1)
#define	EVT_BREAK	(-2)
#endif

#ifndef	EVTIGN_MOUSE
#define	EVTIGN_MOUSE	(1)		/* }EXCxg֎~	*/
#define	EVTIGN_KEY		(2)		/* L[Cxg֎~		*/
#endif

#ifndef	EVTYPE_KEY
#define	EVTYPE_KEY		(1)
#define	KEYEVT_ADR		(0)	/* L[AhXv		*/
#define	KEYEVT_SHIFT	(1)	/* L[Vtgv			*/
#endif

#ifndef	EVTYPE_MOUSE
#define	EVTYPE_MOUSE	(2)
#define	EVTYPE_MOS2		(3)	/* page 0 p}EXCxg	*/
#endif

#ifndef	BTN_LEFT
#define	BTN_LEFT		(1)
#define	BTN_RIGHT		(2)
#define	MOSEVT_BTN		(0x01)	/* {^^Cv					*/
#define	MOSEVT_NOT		(0x02)	/* {^]^Cv				*/
#define	MOSEVT_NOACT	(0x03)	/* {^IANVȂ		*/
#define	MOSEVT_AREA		(0x04)	/* wGA					*/
#define	MOSEVT_OUTAREA	(0x05)	/* wGAO					*/
#define	MOSEVT_BTNOLY	(0x06)	/* {^ꂽꍇ			*/
#define	MOSEVT_MOVE		(0x07)	/* J[\Ɉړꍇ	*/
#define	MOSEVT_OUTBTN	(0x08)	/* ͈͊OŃ{^ON				*/

#define	MOSEVT_REPEAT	(0x10)	/* s[g^Cvi{^j		*/
#define	MOSEVT_QUICK	(0x10)	/* NCbN^Cvi߰ĂƓj	*/
#endif

/*************************************************************************
*	}EXp
*************************************************************************/
#ifndef	MOS_CON
#define	MOS_CON()	MOS_curDisp(1)
#define	MOS_COFF()	MOS_curDisp(0)
#define	MOS_DEC()	MOS_curDisp(2)
#define	MOS_INC()	MOS_curDisp(3)
#endif

/*************************************************************************
*	_CAOp
*************************************************************************/
#ifndef	DLGPOS_MOS_SET_HOME
#define	DLGPOS_MOS_SET_HOME		(0x10010)	/* }EXʒuij	*/
#define	DLGPOS_MOS_SET_CENTER	(0x10020)	/* }EXʒu		*/
#define	DLGPOS_CENTER_OF_SCN	(0x10030)	/* ʒ				*/
#endif

#ifndef	DLGMSG_POS_CONTINUE
#define	DLGMSG_POS_CONTINUE		(-1)
#define	DLGMSG_POS_CENTERING	(-2)
#endif

/*************************************************************************
*	j[p
*************************************************************************/

#ifndef	MNU_BLK
#define	MNU_BLK	(0)
#define	MNU_MSG	(1)
#define	MNU_NOR	(2)
#define	MNU_DIG	(3)
#define	MNU_STR	(4)
#define	MNU_SEL	(5)
#define	MNU_IGN	(0x80)	/* s֎~	*/

#define	MNUATT_EXIT	(1)		/* EXIT {^t	*/
#define	MNUATT_LOOP	(2)		/* LOOP tO		*/
#endif

#ifndef	MENU_SURE_OK
#define	MENU_SURE_OK		(1)
#define	SELBTN_ATT_LEFT		(0)	/* lߕ\				*/
#define	SELBTN_ATT_CENTER	(1)	/* bZ[W̃Z^O	*/
#endif

/*************************************************************************
*	t@C_CAO
*************************************************************************/

#define	FDL_MODE_SINGLE			(0x00000001)	/* t@CЂƂI^w		*/
#define	FDL_MODE_MULTI			(0x00000002)	/* I^w						*/
#define	FDL_MODE_PATH			(0x00000003)	/* fBNgI^w				*/
#define	FDL_MODE_BIT_DIRIGN		(0x00000080)	/* TufBNg̑I^w֎~	*/
#define	FDL_MODE_BIT_DUPIGN		(0x00000800)	/* t@C1̑I֎~		*/
#define	FDL_MODE_BIT_EXIST		(0x00008000)	/* ݂t@ĈݑI\			*/
#define	FDL_MODE_BIT_SIDEWORK	(0x00010000)	/* TCh[N							*/
#define	FDL_MODE_BIT_DOSCALL	(0x00020000)	/* DOS R}h							*/
#define	FDL_MODE_DEFAULT	(FDL_MODE_SINGLE|FDL_MODE_BIT_DIRIGN|FDL_MODE_BIT_SIDEWORK)

#define	FDL_SORT_OFF		(0)			/* \[gȂ		*/
#define	FDL_SORT_FILE		(1)			/* t@C		*/
#define	FDL_SORT_SUB		(2)			/* gq			*/
#define	FDL_SORT_DATE		(3)			/* t				*/
#define	FDL_SORT_SIZE		(4)			/* TCY			*/
#define	FDL_SORT_RVS		(0x80)		/* ^~		*/
#define	FDL_SORT_DIRBIT		(0x60)
#define	FDL_SORT_DIRTOP		(0x00)		/* fBNg擪	*/
#define	FDL_SORT_DIRLAST	(0x20)		/* fBNgŌ	*/
#define	FDL_SORT_DIROFF		(0x40)		/* fBNg		*/

#define	FDL_ISSORT_DIRTOP(_sort)	(((_sort)&FDL_SORT_DIRBIT) == FDL_SORT_DIRTOP)
#define	FDL_ISSORT_DIRLAST(_sort)	(((_sort)&FDL_SORT_DIRBIT) == FDL_SORT_DIRLAST)
#define	FDL_ISSORT_DIROFF(_sort)	(((_sort)&FDL_SORT_DIRBIT) == FDL_SORT_DIROFF)

/*************************************************************************
*	\^J[
*************************************************************************/

#ifndef	C_BLACK
#define	C_BLACK		0
#define	C_BLUE		1
#define	C_RED		2
#define	C_MAGENTA	3
#define	C_GREEN		4
#define	C_CYAN		5
#define	C_YELLOW	6
#define	C_WHITE		7
#define	C_HBLACK	8
#define	C_HBLUE		9
#define	C_HRED		10
#define	C_HMAGENTA	11
#define	C_HGREEN	12
#define	C_HCYAN		13
#define	C_HYELLOW	14
#define	C_HWHITE	15

#define	C_THROUGH	0
#define	C_MBLACK	1
#endif

#define	C_GRAY		C_WHITE
#define	C_DARK		C_HBLACK
#define	C_WARNNING	C_HYELLOW
#define	C_ERROR		C_HRED
#define	C_INFO		C_HGREEN
#define	C_TIMEBOX	C_CYAN
#define	C_GRAY0		C_HBLACK
#define	C_GRAY1		C_RED
#define	C_GRAY2		C_WHITE
#define	C_GRAY3		C_MAGENTA
#define	C_METAL0	C_GREEN
#define	C_METAL1	C_CYAN
#define	C_METAL2	C_YELLOW
#define	C_DLGBASE	C_MAGENTA

#ifndef	PSET
#define	PSET	0
#define	PRESET	1
#define	OR		2
#define	AND		3
#define	XOR		4
#define	NOT		5
#define	OPAQUE	9
#endif

#ifndef	MASKSET
#define	MASKSET		13
#define	MASKRESET	14
#define	MASTNOT		15
#endif

#ifndef	COLMIX
#define	COLMIX(c1,c2)	(0x1000|(((c1)&15)<<4)|((c2)&15))
#endif

/*************************************************************************
*	IMG
*************************************************************************/

#define	IMG_ATT_PLTON	(0x00010000)

/*************************************************************************
*	t@C
*************************************************************************/

#define	FCOPY_OVERWRITE_CHECK	(0x01)	/* ㏑mF			*/
#define	FCOPY_TIME_CHECK		(0x02)	/* tr					*/
#define	FCOPY_SINGLE_COPY		(0x04)	/* t@CЂƂ	*/
#define	FCOPY_LAST_MSG_IGN		(0x80)	/* Ō̃bZ[W\֎~	*/


/*************************************************************************
*	L[R[h^AhX
*************************************************************************/

#define	KA_BIT_SHIFT	(0x04)
#define	KA_BIT_CTRL		(0x10)

#define	KC_CAN		0x03	/* ݾ [CTRL+C]	*/
#define	KC_CR		0x0D	/* RETURN	*/
#define	KC_LF		0x0A	/* LF		*/
#define	KC_BS		0x08	/* ޯ ߰	*/
#define	KC_TAB		0x09	/* TAB		*/
#define	KC_ESC		0x1B	/* ESC	*/

#define	KA_ESC		0x0100	/* [ESC]		*/
#define	KA_1		0x0200
#define	KA_2		0x0300
#define	KA_3		0x0400
#define	KA_4		0x0500
#define	KA_5		0x0600
#define	KA_6		0x0700
#define	KA_7		0x0800
#define	KA_8		0x0900
#define	KA_9		0x0A00
#define	KA_0		0x0B00
#define KA_BS		0x0F00	/* [BS]			*/
#define KA_TAB		0x1000	/* [TAB]			*/

#define	KA_Q		0x1100
#define	KA_W		0x1200
#define	KA_E		0x1300
#define	KA_R		0x1400
#define	KA_T		0x1500
#define	KA_Y		0x1600
#define	KA_U		0x1700
#define	KA_I		0x1800
#define	KA_O		0x1900
#define	KA_P		0x1A00

#define	KA_A		0x1E00
#define	KA_S		0x1F00
#define	KA_D		0x2000
#define	KA_F		0x2100
#define	KA_G		0x2200
#define	KA_H		0x2300
#define	KA_J		0x2400
#define	KA_K		0x2500
#define	KA_L		0x2600
#define	KA_SEMICOLON 0x2700	/* ; */

#define	KA_Z		0x2A00
#define	KA_X		0x2B00
#define	KA_C		0x2C00
#define	KA_V		0x2D00
#define	KA_B		0x2E00
#define	KA_N		0x2F00
#define	KA_M		0x3000

#define	KA_SPACE	0x3500
#define	KA_RETURN	0x1D00	/* [RETURN]		*/
#define	KA_DEL		0x4B00	/* Del			*/
#define	KA_INS		0x4800	/* }			*/
#define	KA_LEFT		0x4F00	/* Left  []	*/
#define	KA_RIGHT	0x5100	/* Right []	*/
#define	KA_UP		0x4D00	/* Up    []	*/
#define	KA_DOWN		0x5000	/* Down  []	*/
#define	KA_HOME		0x4E00	/* [HOME]		*/
#define	KA_PREV		0x6E00	/* [Os]		*/
#define	KA_NEXT		0x7000	/* [s]		*/
#define	KA_BEFORE	0x6E00	/* [Os](old)	*/

#define	KA_OASLEFT	0x6700	/* [Vtg] ewVtgL[{[h	*/
#define	KA_OASRIGHT	0x6800	/* [VtgE] ewVtgL[{[h	*/

#define	KA_KANDIC	0x6B00	/* []	*/
#define	KA_KANDEL	0x6C00	/* [Pꖕ]	*/
#define	KA_KANSET	0x6D00	/* [Po^]	*/
#define	KA_KANHZ	0x7100	/* [pSp]	*/

#define	KA_CANCEL	0x7200	/* []	*/
#define	KA_EXEC		0x7300	/* [s]	*/
#define	KA_BREAK	0x7C00	/* [BREAK]	*/
#define	KA_COPY		0x7D00	/* [COPY]	*/

#define	KA_PF1		0x5D00	/* [PF-1]	*/
#define	KA_PF2		0x5E00	/* [PF-2]	*/
#define	KA_PF3		0x5F00	/* [PF-3]	*/
#define	KA_PF4		0x6000	/* [PF-4]	*/
#define	KA_PF5		0x6100	/* [PF-5]	*/
#define	KA_PF6		0x6200	/* [PF-6]	*/
#define	KA_PF7		0x6300	/* [PF-7]	*/
#define	KA_PF8		0x6400	/* [PF-8]	*/
#define	KA_PF9		0x6500	/* [PF-9]	*/
#define	KA_PF10		0x6600	/* [PF10]	*/
#define	KA_PF11		0x6900	/* [PF11]	*/
#define	KA_PF12		0x5B00	/* [PF12]	*/
#define	KA_PF13		0x7400
#define	KA_PF14		0x7500
#define	KA_PF15		0x7600
#define	KA_PF16		0x7700
#define	KA_PF17		0x7800
#define	KA_PF18		0x7900
#define	KA_PF19		0x7A00
#define	KA_PF20		0x7B00

#endif
